
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class GetSamplingBiasUTRSeqs {
	public String run(String ProteinsInConnectedNetworkSequenceFile){
		String outputFile = "";
		try{
			
			//Changed 11/21/2014
			//BufferedReader in = new BufferedReader(new FileReader(new File("data_noHub/ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_5'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13.txt")));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File("data_noHub/SamplingBiasForMotifSize8Biogrid_UTR5_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13.txt")));
			BufferedReader in = new BufferedReader(new FileReader(new File(ProteinsInConnectedNetworkSequenceFile)));
			outputFile = "SamplingBiasMaxLength"+ outputFile;
			BufferedWriter out = new BufferedWriter(new FileWriter(new File(outputFile)));
			
			
			String s = in.readLine();
			
			while(s != null){
				String[] split = s.split("\t");
				String proteinName = split[0];
				int startIndexSeq = (int)Math.ceil((double)split.length/2.0);
				double seqLengths = 0;
				for(int i = startIndexSeq; i < split.length; i++){
					double lengthToAdd = split[i].length();
					if(lengthToAdd > 500){
						lengthToAdd =500;
					}
					seqLengths = seqLengths + lengthToAdd;
				}
				//if(seqLengths > 500){
				//	seqLengths = 500;
				//}
				out.write(proteinName+"\t"+seqLengths+"\n");
				out.flush();
				
				
				s = in.readLine();
			}
			
			
			out.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return outputFile;
	}
}
