
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;

public class LeaveOutMotifWithTooManyProteins {
	
	//Changed on 11/21/2014
	public LeaveOutMotifWithTooManyProteins(){
	
	}
	
	public Pair<String,String> run(String MotifsWithTooManyGenesFile, String MotifsWithTooManyGenesFileRand, String AllMotifsFile, String AllMotifsFileRand){
	//Changed on 11/21/2014
	//public static void main(String[] args){
		
		String outputMotifAnnotationFile = "";
		String outputMotifAnnotationFileRand = "";
		try{
			
			//Changed on 11/21/2014
			BufferedReader inTooMany = new BufferedReader(new FileReader(new File(MotifsWithTooManyGenesFile)));
			//BufferedReader inTooMany = new BufferedReader(new FileReader(new File("data_noHub/MotifSize8_UTR5_WithTooManyGenes1500_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13.txt")));
			//Changed on 11/21/2014
			BufferedReader inTooManyRand = new BufferedReader(new FileReader(new File(MotifsWithTooManyGenesFileRand)));
			//BufferedReader inTooManyRand = new BufferedReader(new FileReader(new File("data_noHub/MotifSize8_UTR5_WithTooManyGenes1500_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13_Randomized.txt")));

			HashSet<String> motifsTooMany = new HashSet<String>();
			String s = inTooMany.readLine();
			while(s != null){
				motifsTooMany.add(s);
				s = inTooMany.readLine();
			}
			System.out.println("Number of Motifs with too many genes: " + motifsTooMany.size());
			
			HashSet<String> motifsTooManyRand = new HashSet<String>();
			s = inTooManyRand.readLine();
			while(s != null){
				motifsTooManyRand.add(s);
				s = inTooManyRand.readLine();
			}
			System.out.println("Number of Motifs Randomized with too many genes: " + motifsTooManyRand.size());
			
			//Changed on 11/21/2014
			BufferedReader in = new BufferedReader(new FileReader(new File((AllMotifsFile))));
			BufferedReader inRand = new BufferedReader(new FileReader(new File((AllMotifsFileRand))));
			//BufferedReader in = new BufferedReader(new FileReader(new File(("data_noHub/AllMotifSize8_UTR5_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13.txt"))));
			//BufferedReader inRand = new BufferedReader(new FileReader(new File(("data_noHub/AllMotifSize8_UTR5_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13_Randomized.txt"))));
			
			outputMotifAnnotationFile = AllMotifsFile+"_WithLessThan1500";
			outputMotifAnnotationFileRand = AllMotifsFileRand+"_WithLessThan1500";
			BufferedWriter out = new BufferedWriter(new FileWriter(new File((outputMotifAnnotationFile))));
			BufferedWriter outRand = new BufferedWriter(new FileWriter(new File((outputMotifAnnotationFileRand))));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File(("data_noHub/AllMotifSize8_UTR5_GenomeBrowser_RefSeq_MaxLength500_MotifWith1500GenesOrLessInBothSet_nohub_20Mar13.txt"))));
			//BufferedWriter outRand = new BufferedWriter(new FileWriter(new File(("data_noHub/AllMotifSize8_UTR5_GenomeBrowser_RefSeq_MaxLength500_MotifWith1500GenesOrLessInBothSet_nohub_20Mar13_Randomized.txt"))));
			
			
			s = in.readLine();
			String sRand = inRand.readLine();
			while(s != null){
				String[] split = s.split("\t");
				String[] splitRand = sRand.split("\t");
				if(split[0].equals(splitRand[0])){
					if(!motifsTooMany.contains(split[0]) && !motifsTooManyRand.contains(splitRand[0])){
						out.write(s+"\n");
						outRand.write(sRand+"\n");
						out.flush();
						outRand.flush();
					}
					
				}
				else{
					System.out.println("WARNING NOT THE SAME MOTIF");
				}
				
				s = in.readLine();
				sRand = inRand.readLine();
			}
			out.close();
			outRand.close();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return new Pair<String,String>(outputMotifAnnotationFile,outputMotifAnnotationFileRand);
	}
}
