

import java.util.List;
import java.util.Set;

public class TreeNode {
	private TreeNode aParent;
	private TreeNode aChild1;
	private TreeNode aChild2;
	private List<Pair<Protein,List<Protein>>> aProteins;
	private double aPvalue;
	private List<Integer> aIndexes;
	private boolean inTree = false;
	private double aPairwiseDistance;
	
	TreeNode(TreeNode pParent, TreeNode pChild1, TreeNode pChild2, List<Pair<Protein,List<Protein>>> pProteins,double pPvalue,List<Integer> pIndexes, double pPairwiseDistance){
		aParent = pParent;
		aChild1 = pChild1;
		aChild2 = pChild2;
		aProteins = pProteins;
		aPvalue = pPvalue;
		aIndexes = pIndexes;
		aPairwiseDistance = pPairwiseDistance;
	}
	
	public double getPairwiseDistance(){
		return aPairwiseDistance;
	}
	
	public List<Integer> getIndexes(){
		return aIndexes;
	}
	
	public List<Pair<Protein,List<Protein>>> getProteins(){
		return aProteins;
	}
	
	public boolean isInTree(){
		return inTree;
	}
	
	public void InTree(){
		inTree = true;
	}
	
	public double getPvalue(){
		return aPvalue;
	}
	
	public TreeNode getChild1(){
		return aChild1;
	}
	
	public TreeNode getChild2(){
		return aChild2;
	}
}
